#include <immintrin.h>
#include "vecsum.h"

void sum_sse(int A[4], int B[4], int C[4]) {
	__m128i a, b, c;
	a = _mm_load_si128((const __m128i*)A);
	b = _mm_load_si128((const __m128i*)B);
	c = _mm_add_epi32(a,b);
	_mm_store_si128((__m128i*)C, c);
}

void vecsum(int* A, int* B, int* C, int n) {
	int i;
	for (i=0; i+3<n; i+=4) sum_sse(A+i, B+i, C+i);
	for (;i<n; i++)	C[i] = A[i] + B[i];
}
